org.apache.hc.core5.testing.nio

## Class AsyncRequester

- java.lang.Object
- - org.apache.hc.core5.testing.nio.AsyncRequester

- All Implemented Interfaces:
    AutoCloseable, ConnectionInitiator
  Direct Known Subclasses:
    H2TestClient, Http1TestClient

      public class AsyncRequester
      extends Object
      implements ConnectionInitiator

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `AsyncRequester(IOReactorConfig ioReactorConfig)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `awaitShutdown(TimeValue waitTime)`
    `void` | `close()`
    `Future<IOSession>` | `connect(NamedEndpoint remoteEndpoint, SocketAddress remoteAddress, SocketAddress localAddress, Timeout timeout, Object attachment, FutureCallback<IOSession> callback)` Requests a connection to a remote host.
    `protected void` | `execute(IOEventHandlerFactory ioEventHandlerFactory)`
    `IOReactorStatus` | `getStatus()`
    `void` | `initiateShutdown()`
    `Future<IOSession>` | `requestSession(HttpHost host, Timeout timeout, FutureCallback<IOSession> callback)`
    `void` | `shutdown(TimeValue graceTime)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### AsyncRequester

          public AsyncRequester(IOReactorConfig ioReactorConfig)

  - ### Method Detail

    - #### requestSession

          public Future<IOSession> requestSession(HttpHost host,
                                         Timeout timeout,
                                         FutureCallback<IOSession> callback)

    - #### connect

          public Future<IOSession> connect(NamedEndpoint remoteEndpoint,
                                  SocketAddress remoteAddress,
                                  SocketAddress localAddress,
                                  Timeout timeout,
                                  Object attachment,
                                  FutureCallback<IOSession> callback)

      Description copied from interface: `ConnectionInitiator`
      Requests a connection to a remote host.

      Opening a connection to a remote host usually tends to be a time consuming process and may take a while to complete. One can monitor and control the process of session initialization by means of the `Future` interface.

      There are several parameters one can use to exert a greater control over the process of session initialization:

      A non-null local socket address parameter can be used to bind the socket to a specific local address.

      An attachment object can added to the new session's context upon initialization. This object can be used to pass an initial processing state to the protocol handler.

      It is often desirable to be able to react to the completion of a session request asynchronously without having to wait for it, blocking the current thread of execution. One can optionally provide an implementation `FutureCallback` instance to get notified of events related to session requests, such as request completion, cancellation, failure or timeout.

      Specified by:
        `connect` in interface `ConnectionInitiator`
      Parameters:
        `remoteEndpoint` - name of the remote host.
        `remoteAddress` - remote socket address.
        `localAddress` - local socket address. Can be `null`, in which can the default local address and a random port will be used.
        `timeout` - connect timeout.
        `attachment` - the attachment object. Can be `null`.
        `callback` - interface. Can be `null`.
      Returns:
        session request object.

    - #### execute

          protected void execute(IOEventHandlerFactory ioEventHandlerFactory)
                          throws IOException

      Throws:
        `IOException`

    - #### getStatus

          public IOReactorStatus getStatus()

    - #### awaitShutdown

          public void awaitShutdown(TimeValue waitTime)
                             throws InterruptedException

      Throws:
        `InterruptedException`

    - #### initiateShutdown

          public void initiateShutdown()

    - #### shutdown

          public void shutdown(TimeValue graceTime)

    - #### close

          public void close()
                     throws Exception

      Specified by:
        `close` in interface `AutoCloseable`
      Throws:
        `Exception`

Copyright © 2005–2020 The Apache Software Foundation. All rights reserved.